/* S/390-32 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2008-2011, 2014 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define GMP_LIMB_BYTES 4

/* 4400 MHz IBM z196 running in 32-bit mode */
/* FFT tuning limit = 0.5M */
/* Generated by tuneup.c, 2017-01-02, gcc 4.9 */

#define DIVREM_1_NORM_THRESHOLD          MP_SIZE_T_MAX  /* never */
#define DIVREM_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define MOD_1_1P_METHOD                      2
#define MOD_1_NORM_THRESHOLD             MP_SIZE_T_MAX  /* never */
#define MOD_1_UNNORM_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define MOD_1N_TO_MOD_1_1_THRESHOLD         45
#define MOD_1U_TO_MOD_1_1_THRESHOLD         18
#define MOD_1_1_TO_MOD_1_2_THRESHOLD         0  /* never mpn_mod_1_1p */
#define MOD_1_2_TO_MOD_1_4_THRESHOLD     MP_SIZE_T_MAX
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD      3
#define USE_PREINV_DIVREM_1                  0
#define DIV_QR_1N_PI1_METHOD                 1
#define DIV_QR_1_NORM_THRESHOLD          MP_SIZE_T_MAX  /* never */
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 6
#define BMOD_1_TO_MOD_1_THRESHOLD            0  /* always */

#define DIV_1_VS_MUL_1_PERCENT             320

#define MUL_TOOM22_THRESHOLD                12
#define MUL_TOOM33_THRESHOLD                81
#define MUL_TOOM44_THRESHOLD               130
#define MUL_TOOM6H_THRESHOLD               173
#define MUL_TOOM8H_THRESHOLD               260

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      81
#define MUL_TOOM32_TO_TOOM53_THRESHOLD      91
#define MUL_TOOM42_TO_TOOM53_THRESHOLD      83
#define MUL_TOOM42_TO_TOOM63_THRESHOLD      86
#define MUL_TOOM43_TO_TOOM54_THRESHOLD     112

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 18
#define SQR_TOOM3_THRESHOLD                 69
#define SQR_TOOM4_THRESHOLD                178
#define SQR_TOOM6_THRESHOLD                254
#define SQR_TOOM8_THRESHOLD                406

#define MULMID_TOOM42_THRESHOLD             30

#define MULMOD_BNM1_THRESHOLD               12
#define SQRMOD_BNM1_THRESHOLD                7

#define MUL_FFT_MODF_THRESHOLD             276  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    276, 5}, {     15, 6}, {      8, 5}, {     17, 6}, \
    {      9, 5}, {     19, 6}, {     13, 7}, {      7, 6}, \
    {     17, 7}, {      9, 6}, {     19, 7}, {     11, 6}, \
    {     23, 7}, {     13, 8}, {      7, 7}, {     19, 8}, \
    {     11, 7}, {     25, 8}, {     15, 7}, {     31, 8}, \
    {     19, 7}, {     39, 8}, {     23, 9}, {     15, 8}, \
    {     39, 9}, {     23,10}, {     15, 9}, {     31, 8}, \
    {     67, 9}, {     39, 8}, {     79, 9}, {     47,10}, \
    {     31, 9}, {     71, 8}, {    143, 9}, {     79,10}, \
    {     47,11}, {     31,10}, {     63, 9}, {    127, 8}, \
    {    255, 7}, {    511, 9}, {    143,10}, {     79, 9}, \
    {    159, 8}, {    319, 9}, {    175, 8}, {    351,10}, \
    {     95, 9}, {    191, 8}, {    383,11}, {     63,10}, \
    {    127, 9}, {    255, 8}, {    511,10}, {    143, 9}, \
    {    287, 8}, {    575,10}, {    159, 9}, {    319,10}, \
    {    175, 9}, {    351,11}, {     95,10}, {    191, 9}, \
    {    383,12}, {     63,11}, {    127,10}, {    255, 9}, \
    {    511,10}, {    271, 9}, {    543, 8}, {   1087,10}, \
    {    287, 9}, {    575,11}, {    159,10}, {    351, 9}, \
    {    703, 8}, {   1407,11}, {    191,10}, {    415, 9}, \
    {    831,11}, {    223,10}, {    479, 9}, {    959, 8}, \
    {   1919,12}, {   4096,13}, {   8192,14}, {  16384,15}, \
    {  32768,16} }
#define MUL_FFT_TABLE3_SIZE 89
#define MUL_FFT_THRESHOLD                 2688

#define SQR_FFT_MODF_THRESHOLD             240  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    240, 5}, {     17, 6}, {     17, 7}, {      9, 6}, \
    {     19, 7}, {     11, 6}, {     23, 7}, {     13, 8}, \
    {      7, 7}, {     19, 8}, {     11, 7}, {     25, 8}, \
    {     15, 7}, {     33, 8}, {     19, 7}, {     39, 8}, \
    {     23, 9}, {     15, 8}, {     39, 9}, {     23,10}, \
    {     15, 9}, {     31, 8}, {     63, 9}, {     47,10}, \
    {     31, 9}, {     63, 8}, {    127, 9}, {     71, 8}, \
    {    143,10}, {     47,11}, {     31,10}, {     63, 9}, \
    {    127, 8}, {    255, 7}, {    511, 9}, {    143,10}, \
    {     79, 9}, {    159, 8}, {    319, 9}, {    175, 8}, \
    {    351, 7}, {    703,10}, {     95, 9}, {    191, 8}, \
    {    383, 9}, {    207, 8}, {    415,11}, {     63,10}, \
    {    127, 9}, {    255, 8}, {    511,10}, {    143, 9}, \
    {    287, 8}, {    575,10}, {    159, 9}, {    319,10}, \
    {    175, 9}, {    351, 8}, {    703, 7}, {   1407,11}, \
    {     95,10}, {    191, 9}, {    383,10}, {    207, 9}, \
    {    415,12}, {     63,11}, {    127,10}, {    255, 9}, \
    {    511,10}, {    287, 9}, {    575,11}, {    159,10}, \
    {    351, 9}, {    703, 8}, {   1407,11}, {    191,10}, \
    {    415, 9}, {    831,11}, {    223,10}, {    479,12}, \
    {   4096,13}, {   8192,14}, {  16384,15}, {  32768,16} }
#define SQR_FFT_TABLE3_SIZE 84
#define SQR_FFT_THRESHOLD                 1856

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                  27
#define MULLO_MUL_N_THRESHOLD             5240
#define SQRLO_BASECASE_THRESHOLD             0  /* always */
#define SQRLO_DC_THRESHOLD                  65
#define SQRLO_SQR_THRESHOLD               3470

#define DC_DIV_QR_THRESHOLD                 32
#define DC_DIVAPPR_Q_THRESHOLD             135
#define DC_BDIV_QR_THRESHOLD                32
#define DC_BDIV_Q_THRESHOLD                 80

#define INV_MULMOD_BNM1_THRESHOLD           42
#define INV_NEWTON_THRESHOLD               177
#define INV_APPR_THRESHOLD                 139

#define BINV_NEWTON_THRESHOLD              179
#define REDC_1_TO_REDC_N_THRESHOLD          39

#define MU_DIV_QR_THRESHOLD                872
#define MU_DIVAPPR_Q_THRESHOLD             998
#define MUPI_DIV_QR_THRESHOLD               66
#define MU_BDIV_QR_THRESHOLD               748
#define MU_BDIV_Q_THRESHOLD                906

#define POWM_SEC_TABLE  9,34,257,946,2913

#define GET_STR_DC_THRESHOLD                10
#define GET_STR_PRECOMPUTE_THRESHOLD        16
#define SET_STR_DC_THRESHOLD              1045
#define SET_STR_PRECOMPUTE_THRESHOLD      1800

#define FAC_DSC_THRESHOLD                   77
#define FAC_ODD_THRESHOLD                   24

#define MATRIX22_STRASSEN_THRESHOLD         15
#define HGCD_THRESHOLD                     121
#define HGCD_APPR_THRESHOLD                142
#define HGCD_REDUCE_THRESHOLD             1679
#define GCD_DC_THRESHOLD                   389
#define GCDEXT_DC_THRESHOLD                285
#define JACOBI_BASE_METHOD                   4
