/* x86/k10 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2011, 2014-2015 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define GMP_LIMB_BYTES 4

/* 3200-3600 MHz K10 Thuban */
/* FFT tuning limit = 67,000,000 */
/* Generated by tuneup.c, 2019-10-19, gcc 8.3 */

#define MOD_1_NORM_THRESHOLD                 0  /* always */
#define MOD_1_UNNORM_THRESHOLD               0  /* always */
#define MOD_1N_TO_MOD_1_1_THRESHOLD         14
#define MOD_1U_TO_MOD_1_1_THRESHOLD          7
#define MOD_1_1_TO_MOD_1_2_THRESHOLD         0  /* never mpn_mod_1_1p */
#define MOD_1_2_TO_MOD_1_4_THRESHOLD        18
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD     22
#define USE_PREINV_DIVREM_1                  1  /* native */
#define DIV_QR_1N_PI1_METHOD                 1  /* 29.33% faster than 2 */
#define DIV_QR_1_NORM_THRESHOLD              2
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD           35

#define DIV_1_VS_MUL_1_PERCENT             258

#define MUL_TOOM22_THRESHOLD                22
#define MUL_TOOM33_THRESHOLD                73
#define MUL_TOOM44_THRESHOLD               124
#define MUL_TOOM6H_THRESHOLD               274
#define MUL_TOOM8H_THRESHOLD               430

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      81
#define MUL_TOOM32_TO_TOOM53_THRESHOLD      99
#define MUL_TOOM42_TO_TOOM53_THRESHOLD      85
#define MUL_TOOM42_TO_TOOM63_THRESHOLD      88
#define MUL_TOOM43_TO_TOOM54_THRESHOLD     113

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 26
#define SQR_TOOM3_THRESHOLD                105
#define SQR_TOOM4_THRESHOLD                154
#define SQR_TOOM6_THRESHOLD                238
#define SQR_TOOM8_THRESHOLD                309

#define MULMID_TOOM42_THRESHOLD             50

#define MULMOD_BNM1_THRESHOLD               15
#define SQRMOD_BNM1_THRESHOLD               18

#define MUL_FFT_MODF_THRESHOLD             570  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    570, 5}, {     21, 6}, {     11, 5}, {     25, 6}, \
    {     13, 5}, {     27, 6}, {     15, 5}, {     31, 6}, \
    {     25, 7}, {     13, 6}, {     27, 7}, {     15, 6}, \
    {     32, 7}, {     17, 6}, {     35, 7}, {     19, 6}, \
    {     39, 7}, {     27, 8}, {     15, 7}, {     35, 8}, \
    {     19, 7}, {     41, 8}, {     23, 7}, {     47, 8}, \
    {     27, 9}, {     15, 8}, {     31, 7}, {     63, 8}, \
    {     39, 9}, {     23, 8}, {     55, 9}, {     31, 8}, \
    {     67, 9}, {     39, 8}, {     79, 9}, {     47, 8}, \
    {     95, 9}, {     55,10}, {     31, 9}, {     79,10}, \
    {     47, 9}, {     95,11}, {     31,10}, {     63, 9}, \
    {    135,10}, {     79, 9}, {    159,10}, {     95, 9}, \
    {    191,11}, {     63,10}, {    143, 9}, {    287,10}, \
    {    159,11}, {     95,10}, {    191,12}, {     63,11}, \
    {    127,10}, {    255, 9}, {    511,10}, {    271, 9}, \
    {    543,10}, {    287,11}, {    159,10}, {    319, 9}, \
    {    639,10}, {    335, 9}, {    671,11}, {    191,10}, \
    {    383, 9}, {    767,10}, {    399, 9}, {    799,11}, \
    {    223,12}, {    127,11}, {    255,10}, {    543,11}, \
    {    287,10}, {    607, 9}, {   1215,11}, {    319,10}, \
    {    671,12}, {    191,11}, {    383,10}, {    799,11}, \
    {    415,13}, {    127,12}, {    255,11}, {    543,10}, \
    {   1087,11}, {    607,10}, {   1215,12}, {    319,11}, \
    {    671,10}, {   1343,11}, {    735,10}, {   1471, 9}, \
    {   2943,12}, {    383,11}, {    799,10}, {   1599,11}, \
    {    863,12}, {    447,11}, {    959,13}, {    255,12}, \
    {    511,11}, {   1087,12}, {    575,11}, {   1215,10}, \
    {   2431,12}, {    639,11}, {   1343,12}, {    703,11}, \
    {   1471,10}, {   2943,13}, {    383,12}, {    767,11}, \
    {   1599,12}, {    831,11}, {   1727,10}, {   3455,12}, \
    {    959,11}, {   1919,14}, {    255,13}, {    511,12}, \
    {   1087,11}, {   2239,12}, {   1215,11}, {   2431,13}, \
    {    639,12}, {   1471,11}, {   2943,13}, {    767,12}, \
    {   1727,11}, {   3455,13}, {    895,12}, {   1983,14}, \
    {    511,13}, {   1023,12}, {   2239,13}, {   1151,12}, \
    {   2431,13}, {   1407,12}, {   2943,14}, {    767,13}, \
    {   1663,12}, {   3455,13}, {   1919,15}, {    511,14}, \
    {   1023,13}, {   2175,12}, {   4479,13}, {   2431,14}, \
    {   1279,13}, {   2943,12}, {   5887,14}, {   1535,13}, \
    {   3455,14}, {   1791,13}, {   3967,15}, {   1023,14}, \
    {   2047,13}, {   4479,14}, {   2303,13}, {   4991,14}, \
    {   2815,13}, {   5887,15}, {   1535,14}, {   3839,16} }
#define MUL_FFT_TABLE3_SIZE 168
#define MUL_FFT_THRESHOLD                 7424

#define SQR_FFT_MODF_THRESHOLD             525  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    525, 5}, {     25, 6}, {     13, 5}, {     28, 6}, \
    {     25, 7}, {     13, 6}, {     27, 7}, {     15, 6}, \
    {     31, 7}, {     17, 6}, {     35, 7}, {     19, 6}, \
    {     39, 7}, {     27, 8}, {     15, 7}, {     35, 8}, \
    {     19, 7}, {     41, 8}, {     23, 7}, {     47, 8}, \
    {     27, 9}, {     15, 8}, {     31, 7}, {     63, 8}, \
    {     39, 9}, {     23, 8}, {     51, 9}, {     31, 8}, \
    {     67, 9}, {     39, 8}, {     79, 9}, {     55,10}, \
    {     31, 9}, {     79,10}, {     47, 9}, {     95,11}, \
    {     31,10}, {     63, 9}, {    127,10}, {     79, 9}, \
    {    159,10}, {     95,11}, {     63,10}, {    143, 9}, \
    {    287,10}, {    159,11}, {     95,10}, {    191,12}, \
    {     63,11}, {    127,10}, {    255, 9}, {    511,10}, \
    {    271, 9}, {    543,10}, {    287,11}, {    159,10}, \
    {    319, 9}, {    639,10}, {    335, 9}, {    671,10}, \
    {    351,11}, {    191,10}, {    383, 9}, {    767,10}, \
    {    399, 9}, {    799,10}, {    415,12}, {    127,11}, \
    {    255,10}, {    543,11}, {    287,10}, {    607,11}, \
    {    319,10}, {    671, 9}, {   1343,11}, {    351,10}, \
    {    703,12}, {    191,11}, {    383,10}, {    799, 9}, \
    {   1599,11}, {    415,10}, {    831,13}, {    127,12}, \
    {    255,11}, {    543,10}, {   1087,11}, {    607,12}, \
    {    319,11}, {    671,10}, {   1343,11}, {    735,10}, \
    {   1471,12}, {    383,11}, {    799,10}, {   1599,11}, \
    {    863,10}, {   1727,12}, {    447,11}, {    959,10}, \
    {   1919,11}, {    991,12}, {    511,11}, {   1087,12}, \
    {    575,11}, {   1215,10}, {   2431,12}, {    639,11}, \
    {   1343,12}, {    703,11}, {   1471,13}, {    383,12}, \
    {    767,11}, {   1599,12}, {    831,11}, {   1727,10}, \
    {   3455,12}, {    959,11}, {   1919,13}, {    511,12}, \
    {   1087,11}, {   2239,12}, {   1215,11}, {   2431,13}, \
    {    639,12}, {   1471,11}, {   2943,13}, {    767,12}, \
    {   1727,11}, {   3455,13}, {    895,12}, {   1919,14}, \
    {    511,13}, {   1023,12}, {   2239,13}, {   1151,12}, \
    {   2495,13}, {   1279,12}, {   2623,13}, {   1407,12}, \
    {   2943,14}, {    767,13}, {   1663,12}, {   3455,13}, \
    {   1919,15}, {    511,14}, {   1023,13}, {   2175,12}, \
    {   4351,13}, {   2431,14}, {   1279,13}, {   2943,12}, \
    {   5887,14}, {   1535,13}, {   3455,14}, {   1791,13}, \
    {   3967,15}, {   1023,14}, {   2047,13}, {   4351,14}, \
    {   2303,13}, {   4991,14}, {   2815,13}, {   5887,15}, \
    {   1535,14}, {   3839,16} }
#define SQR_FFT_TABLE3_SIZE 166
#define SQR_FFT_THRESHOLD                 5312

#define MULLO_BASECASE_THRESHOLD             6
#define MULLO_DC_THRESHOLD                  40
#define MULLO_MUL_N_THRESHOLD            14281
#define SQRLO_BASECASE_THRESHOLD             8
#define SQRLO_DC_THRESHOLD                 113
#define SQRLO_SQR_THRESHOLD              10323

#define DC_DIV_QR_THRESHOLD                 56
#define DC_DIVAPPR_Q_THRESHOLD             248
#define DC_BDIV_QR_THRESHOLD                55
#define DC_BDIV_Q_THRESHOLD                158

#define INV_MULMOD_BNM1_THRESHOLD           42
#define INV_NEWTON_THRESHOLD               254
#define INV_APPR_THRESHOLD                 252

#define BINV_NEWTON_THRESHOLD              292
#define REDC_1_TO_REDC_N_THRESHOLD          67

#define MU_DIV_QR_THRESHOLD               1589
#define MU_DIVAPPR_Q_THRESHOLD            1558
#define MUPI_DIV_QR_THRESHOLD              114
#define MU_BDIV_QR_THRESHOLD              1442
#define MU_BDIV_Q_THRESHOLD               1524

#define POWM_SEC_TABLE  1,16,102,416,1378

#define GET_STR_DC_THRESHOLD                13
#define GET_STR_PRECOMPUTE_THRESHOLD        21
#define SET_STR_DC_THRESHOLD               270
#define SET_STR_PRECOMPUTE_THRESHOLD      1105

#define FAC_DSC_THRESHOLD                  159
#define FAC_ODD_THRESHOLD                   34

#define MATRIX22_STRASSEN_THRESHOLD         17
#define HGCD2_DIV1_METHOD                    3  /* 0.70% faster than 4 */
#define HGCD_THRESHOLD                     130
#define HGCD_APPR_THRESHOLD                163
#define HGCD_REDUCE_THRESHOLD             3389
#define GCD_DC_THRESHOLD                   573
#define GCDEXT_DC_THRESHOLD                393
#define JACOBI_BASE_METHOD                   4  /* 9.13% faster than 1 */

/* Tuneup completed successfully, took 52901 seconds */
