/* VIA Nano gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2010, 2012, 2014 Free Software Foundation,
Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 64
#define GMP_LIMB_BYTES 8

#define SHLD_SLOW 1
#define SHRD_SLOW 1

/* 1600 MHz Nano 2xxx */
/* FFT tuning limit = 25000000 */
/* Generated by tuneup.c, 2014-03-12, gcc 4.2 */

#define MOD_1_NORM_THRESHOLD                 0  /* always */
#define MOD_1_UNNORM_THRESHOLD               0  /* always */
#define MOD_1N_TO_MOD_1_1_THRESHOLD          4
#define MOD_1U_TO_MOD_1_1_THRESHOLD          2
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        18
#define MOD_1_2_TO_MOD_1_4_THRESHOLD        20
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD      8
#define USE_PREINV_DIVREM_1                  1  /* native */
#define DIV_QR_1_NORM_THRESHOLD              1
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD           22

#define MUL_TOOM22_THRESHOLD                27
#define MUL_TOOM33_THRESHOLD                38
#define MUL_TOOM44_THRESHOLD               324
#define MUL_TOOM6H_THRESHOLD               450
#define MUL_TOOM8H_THRESHOLD               632

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      73
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     207
#define MUL_TOOM42_TO_TOOM53_THRESHOLD     211
#define MUL_TOOM42_TO_TOOM63_THRESHOLD     219
#define MUL_TOOM43_TO_TOOM54_THRESHOLD     315

#define SQR_BASECASE_THRESHOLD              10
#define SQR_TOOM2_THRESHOLD                 52
#define SQR_TOOM3_THRESHOLD                 73
#define SQR_TOOM4_THRESHOLD                387
#define SQR_TOOM6_THRESHOLD                662
#define SQR_TOOM8_THRESHOLD                781

#define MULMID_TOOM42_THRESHOLD             32

#define MULMOD_BNM1_THRESHOLD               14
#define SQRMOD_BNM1_THRESHOLD               15

#define MUL_FFT_MODF_THRESHOLD             376  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    376, 5}, {     19, 6}, {     10, 5}, {     21, 6}, \
    {     23, 7}, {     12, 6}, {     25, 7}, {     21, 8}, \
    {     11, 7}, {     24, 8}, {     13, 7}, {     27, 8}, \
    {     15, 7}, {     31, 8}, {     19, 7}, {     39, 8}, \
    {     21, 9}, {     11, 8}, {     27, 9}, {     15, 8}, \
    {     35, 9}, {     19, 8}, {     41, 9}, {     23, 8}, \
    {     49, 9}, {     27,10}, {     15, 9}, {     43,10}, \
    {     23, 9}, {     55,11}, {     15,10}, {     31, 9}, \
    {     67,10}, {     39, 9}, {     83,10}, {     47, 9}, \
    {     95,10}, {     79,11}, {     47,10}, {    103,12}, \
    {     31,11}, {     63,10}, {    143,11}, {     79,10}, \
    {    159, 9}, {    319,10}, {    175,11}, {     95, 9}, \
    {    383, 8}, {    767,10}, {    207,11}, {    111,12}, \
    {     63,11}, {    127,10}, {    255,11}, {    143, 9}, \
    {    575, 8}, {   1151,10}, {    303,11}, {    159,10}, \
    {    319, 9}, {    639, 8}, {   1279,10}, {    335,12}, \
    {     95,11}, {    191,10}, {    383, 9}, {    767,11}, \
    {    207,10}, {    415, 9}, {    831, 8}, {   1663,10}, \
    {    447,13}, {     63,12}, {    127,11}, {    255,10}, \
    {    511, 9}, {   1023,11}, {    271,10}, {    543, 9}, \
    {   1087,10}, {    575, 9}, {   1215,12}, {    159,11}, \
    {    319,10}, {    639, 9}, {   1279,11}, {    335,10}, \
    {    671, 9}, {   1343,11}, {    351,10}, {    703, 9}, \
    {   1407,12}, {    191,11}, {    383,10}, {    767, 9}, \
    {   1535,10}, {    831, 9}, {   1663,12}, {    223,11}, \
    {    447,10}, {    895,13}, {    127,12}, {    255,11}, \
    {    511,10}, {   1023,11}, {    543,10}, {   1087,12}, \
    {    287,11}, {    575,10}, {   1151,11}, {    607,10}, \
    {   1215,12}, {    319,11}, {    639,10}, {   1279,11}, \
    {    671,10}, {   1343,12}, {    351,11}, {    703,10}, \
    {   1407,13}, {    191,12}, {    383,11}, {    767,10}, \
    {   1535,12}, {    415,11}, {    831,10}, {   1663,12}, \
    {    447,11}, {    895,10}, {   1791,14}, {    127,13}, \
    {    255,12}, {    511,11}, {   1023,12}, {    543,11}, \
    {   1087,12}, {    575,11}, {   1151,12}, {    607,11}, \
    {   1215,13}, {    319,12}, {    639,11}, {   1279,12}, \
    {    671,11}, {   1343,12}, {    703,11}, {   1407,13}, \
    {    383,12}, {    767,11}, {   1535,12}, {    831,11}, \
    {   1663,13}, {    447,12}, {    895,11}, {   1791,13}, \
    {    511,12}, {   1023,11}, {   2047,12}, {   1087,13}, \
    {    575,12}, {   1151,11}, {   2303,12}, {   1215,13}, \
    {    639,12}, {   1279,11}, {   2559,12}, {   1343,13}, \
    {    703,12}, {   1407,14}, {    383,13}, {    767,12}, \
    {   1535,13}, {    831,12}, {   1663,13}, {    895,12}, \
    {   1791,13}, {    959,14}, {    511,13}, {   1023,12}, \
    {   2047,13}, {   1087,12}, {   2175,13}, {   1151,12}, \
    {   2303,13}, {   1215,14}, {    639,13}, {   1279,12}, \
    {   2559,13}, {   1407,12}, {   2815,13}, {   1471,14}, \
    {    767,13}, {   1535,12}, {   3071,13}, {   1663,14}, \
    {    895,13}, {   1791,12}, {   3583,13}, {   1919,15}, \
    {    511,14}, {   1023,13}, {   2047,12}, {   4095,13}, \
    {   2175,14}, {   1151,13}, {   2303,12}, {   4607,13}, \
    {   2431,14}, {   1279,13}, {   2559,12}, {   5119,14}, \
    {   1407,13}, {   2815,12}, {   5631,15}, {  32768,16}, \
    {  65536,17}, { 131072,18}, { 262144,19}, { 524288,20}, \
    {1048576,21}, {2097152,22}, {4194304,23}, {8388608,24} }
#define MUL_FFT_TABLE3_SIZE 224
#define MUL_FFT_THRESHOLD                 3520

#define SQR_FFT_MODF_THRESHOLD             340  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    340, 5}, {     19, 6}, {     10, 5}, {     21, 6}, \
    {     21, 7}, {     11, 6}, {     23, 7}, {     21, 8}, \
    {     11, 7}, {     24, 8}, {     13, 7}, {     27, 8}, \
    {     15, 7}, {     31, 8}, {     21, 9}, {     11, 8}, \
    {     27, 9}, {     15, 8}, {     33, 9}, {     19, 8}, \
    {     41, 9}, {     23, 8}, {     47, 9}, {     27,10}, \
    {     15, 9}, {     39,10}, {     23, 9}, {     51,11}, \
    {     15,10}, {     31, 9}, {     67,10}, {     39, 9}, \
    {     79,10}, {     47, 9}, {     95,10}, {     55,11}, \
    {     31,10}, {     63, 9}, {    127,10}, {     71, 9}, \
    {    143,10}, {     79,11}, {     47,10}, {     95, 9}, \
    {    191,10}, {    103,12}, {     31,11}, {     63,10}, \
    {    127, 9}, {    255,10}, {    135, 7}, {   1087, 9}, \
    {    287,11}, {     79, 9}, {    319, 8}, {    639,10}, \
    {    167,11}, {     95,10}, {    191, 9}, {    383, 8}, \
    {    767,11}, {    111,12}, {     63,11}, {    127,10}, \
    {    255, 9}, {    511, 8}, {   1023,10}, {    271, 9}, \
    {    543, 8}, {   1087,11}, {    143, 9}, {    575, 8}, \
    {   1151,10}, {    303, 9}, {    639, 8}, {   1279,10}, \
    {    335, 9}, {    671,10}, {    351, 9}, {    703,12}, \
    {     95,11}, {    191,10}, {    383, 9}, {    767,11}, \
    {    207,10}, {    415, 9}, {    831,13}, {     63,12}, \
    {    127,11}, {    255,10}, {    511, 9}, {   1023,11}, \
    {    271,10}, {    543, 9}, {   1087,10}, {    575, 9}, \
    {   1151,11}, {    303,10}, {    607, 9}, {   1215,12}, \
    {    159,11}, {    319,10}, {    639, 9}, {   1279,10}, \
    {    671, 9}, {   1343,11}, {    351,10}, {    703, 9}, \
    {   1407,12}, {    191,11}, {    383,10}, {    767, 9}, \
    {   1535,11}, {    415,10}, {    831, 9}, {   1663,12}, \
    {    223,11}, {    447,10}, {    959,13}, {    127,12}, \
    {    255,11}, {    511,10}, {   1023,11}, {    543,10}, \
    {   1087,11}, {    575,10}, {   1215,12}, {    319,11}, \
    {    639,10}, {   1279,11}, {    671,10}, {   1343,12}, \
    {    351,11}, {    703,10}, {   1407,13}, {    191,12}, \
    {    383,11}, {    767,10}, {   1535,12}, {    415,11}, \
    {    831,10}, {   1663,12}, {    447,11}, {    895,10}, \
    {   1791,12}, {    479,11}, {    959,14}, {    127,12}, \
    {    511,11}, {   1023,12}, {    543,11}, {   1087,12}, \
    {    575,11}, {   1151,12}, {    607,11}, {   1215,13}, \
    {    319,12}, {    639,11}, {   1279,12}, {    671,11}, \
    {   1343,12}, {    703,11}, {   1407,13}, {    383,12}, \
    {    767,11}, {   1535,12}, {    831,11}, {   1663,13}, \
    {    447,12}, {    895,11}, {   1791,12}, {    959,13}, \
    {    511,12}, {   1023,11}, {   2047,12}, {   1087,13}, \
    {    575,12}, {   1215,13}, {    639,12}, {   1343,13}, \
    {    703,12}, {   1407,11}, {   2815,13}, {    767,12}, \
    {   1535,13}, {    831,12}, {   1663,13}, {    895,12}, \
    {   1791,13}, {    959,14}, {    511,13}, {   1023,12}, \
    {   2047,13}, {   1087,12}, {   2175,13}, {   1215,14}, \
    {    639,13}, {   1279,12}, {   2559,13}, {   1407,12}, \
    {   2815,14}, {    767,13}, {   1535,12}, {   3071,13}, \
    {   1663,14}, {    895,13}, {   1791,12}, {   3583,13}, \
    {   1919,15}, {    511,14}, {   1023,13}, {   2047,12}, \
    {   4095,13}, {   2175,14}, {   1151,13}, {   2303,12}, \
    {   4607,14}, {   1279,13}, {   2559,14}, {   1407,13}, \
    {   2815,15}, {  32768,16}, {  65536,17}, { 131072,18}, \
    { 262144,19}, { 524288,20}, {1048576,21}, {2097152,22}, \
    {4194304,23}, {8388608,24} }
#define SQR_FFT_TABLE3_SIZE 230
#define SQR_FFT_THRESHOLD                 2496

#define MULLO_BASECASE_THRESHOLD            13
#define MULLO_DC_THRESHOLD                  38
#define MULLO_MUL_N_THRESHOLD             6633

#define DC_DIV_QR_THRESHOLD                 56
#define DC_DIVAPPR_Q_THRESHOLD             173
#define DC_BDIV_QR_THRESHOLD                55
#define DC_BDIV_Q_THRESHOLD                 96

#define INV_MULMOD_BNM1_THRESHOLD           54
#define INV_NEWTON_THRESHOLD               202
#define INV_APPR_THRESHOLD                 166

#define BINV_NEWTON_THRESHOLD              246
#define REDC_1_TO_REDC_2_THRESHOLD           7
#define REDC_2_TO_REDC_N_THRESHOLD          85

#define MU_DIV_QR_THRESHOLD               1499
#define MU_DIVAPPR_Q_THRESHOLD            1652
#define MUPI_DIV_QR_THRESHOLD               83
#define MU_BDIV_QR_THRESHOLD              1210
#define MU_BDIV_Q_THRESHOLD               1499

#define POWM_SEC_TABLE  1,28,129,642,2387

#define MATRIX22_STRASSEN_THRESHOLD         15
#define HGCD_THRESHOLD                     127
#define HGCD_APPR_THRESHOLD                214
#define HGCD_REDUCE_THRESHOLD             2479
#define GCD_DC_THRESHOLD                   487
#define GCDEXT_DC_THRESHOLD                505
#define JACOBI_BASE_METHOD                   4

#define GET_STR_DC_THRESHOLD                12
#define GET_STR_PRECOMPUTE_THRESHOLD        24
#define SET_STR_DC_THRESHOLD               802
#define SET_STR_PRECOMPUTE_THRESHOLD      2042

#define FAC_DSC_THRESHOLD                 1737
#define FAC_ODD_THRESHOLD                   44
